Fixing as-needed issues, provide shared libs

https://bugs.gentoo.org/show_bug.cgi?id=294971

--- a/Makefile.am
+++ b/Makefile.am
@@ -1,440 +1,92 @@
 ACLOCAL_AMFLAGS = -I m4
 
-AM_CXXFLAGS =
-AM_CXXFLAGS += -Wall
-AM_CXXFLAGS += $(BOOST_CPPFLAGS)
+AM_CXXFLAGS = -Wall $(BOOST_CPPFLAGS)
+SUFFIXES = .cc 

-
-# for testing
-AM_CXXFLAGS += -g -O2 #-lefence
-
-# for profiling
-#CXXFLAGS    += -O3 -g -pg
-#AM_CXXFLAGS += -O3 -g -pg
-
-# for production
-#CXXFLAGS    += -O3 -fexpensive-optimizations -DNDEBUG
-#AM_CXXFLAGS += -O3 -fexpensive-optimizations -DNDEBUG
-
-# for coverage testing
-#CXXFLAGS    += -g -fprofile-arcs -ftest-coverage -O3 -fexpensive-optimizations
-#AM_CXXFLAGS += -g -fprofile-arcs -ftest-coverage -O3 -fexpensive-optimizations
-
-
-lib_LIBRARIES = libsnpfile.a
+lib_LTLIBRARIES = libsnpfile.la
 
 noinst_PROGRAMS =
-TESTS = 
-EXTRA_DIST =
-bin_PROGRAMS =
 
 # conversion tools
-bin_PROGRAMS += text2snpfile
-bin_PROGRAMS += snpfile2text
-bin_PROGRAMS += snpfile2fastPHASE
-bin_PROGRAMS += fastPHASE2snpfile
-bin_PROGRAMS += snpfile2haploview
-bin_PROGRAMS += beagle_phase_snpfile
+bin_PROGRAMS = text2snpfile snpfile2text snpfile2fastPHASE fastPHASE2snpfile \
+	       snpfile2haploview beagle_phase_snpfile
 
 # data extraction tools
-bin_PROGRAMS += snpfile_genotype_count
-bin_PROGRAMS += snpfile_phenotypes
-bin_PROGRAMS += snpfile_markers
-
-bin_PROGRAMS += snpfile_metadata_info
-bin_PROGRAMS += snpfile_set_metadata
-bin_PROGRAMS += snpfile_get_metadata
+bin_PROGRAMS += snpfile_genotype_count snpfile_phenotypes snpfile_markers
+
+bin_PROGRAMS += snpfile_metadata_info snpfile_set_metadata snpfile_get_metadata
 
 # other tools
 noinst_PROGRAMS += snpfile_split_on_column
 
 # tests
-noinst_PROGRAMS += matrix_test
-TESTS +=           matrix_test
-noinst_PROGRAMS += file_test
-TESTS +=           file_test
-noinst_PROGRAMS += file_matrix_test
-TESTS +=           file_matrix_test
-noinst_PROGRAMS += readonly_matrix_test
-TESTS +=           readonly_matrix_test
-noinst_PROGRAMS += archives_test
-TESTS +=           archives_test
-noinst_PROGRAMS += metadata_access_test
-TESTS +=           metadata_access_test
-noinst_PROGRAMS += metadata_types_test
-TESTS +=           metadata_types_test
-noinst_PROGRAMS += iterators_test
-TESTS +=           iterators_test
-noinst_PROGRAMS += tabulate_test
-TESTS +=           tabulate_test
-noinst_PROGRAMS += metadata_filtering_test
-TESTS +=           metadata_filtering_test
+TESTS = matrix_test file_test file_matrix_test readonly_matrix_test archives_test \
+	metadata_access_test metadata_types_test iterators_test tabulate_test metadata_filtering_test
+
+noinst_PROGRAMS += $(TESTS)
 
 #Utils for testing across different machines
-noinst_PROGRAMS += make_test_snpfile
-noinst_PROGRAMS += test_test_snpfile
+noinst_PROGRAMS += make_test_snpfile test_test_snpfile
 
 # other experiments...
-noinst_PROGRAMS += row_metadata_experiment
-noinst_PROGRAMS += metadata_cache_prototype
-noinst_PROGRAMS += matrix_benchmark
-noinst_PROGRAMS += matrix_benchmark_write
-noinst_PROGRAMS += matrix_benchmark_read
-
-
-
-matrix_test_LDADD =
-matrix_test_LDADD += $(BOOST_SIGNALS_LIB)
-matrix_test_SOURCES =
-matrix_test_SOURCES += test_util.hh test_util.cc
-matrix_test_SOURCES += matrix.hh matrix.cc
-matrix_test_SOURCES += array_matrix.hh array_matrix.cc
-matrix_test_SOURCES += file_matrix.hh file_matrix.cc
-matrix_test_SOURCES += input_archive.hh
-matrix_test_SOURCES += output_archive.hh
-matrix_test_SOURCES += metadata.hh metadata.cc
-matrix_test_SOURCES += snpfile.hh snpfile.cc
-matrix_test_SOURCES += byte_order_handler.hh byte_order_handler.cc
-matrix_test_SOURCES += matrix_test.cc
-
-
-file_test_LDADD =
-file_test_LDADD += $(BOOST_SIGNALS_LIB)
-file_test_SOURCES =
-file_test_SOURCES += test_util.hh test_util.cc
-file_test_SOURCES += metadata.hh metadata.cc
-file_test_SOURCES += snpfile.hh snpfile.cc
-file_test_SOURCES += byte_order_handler.hh byte_order_handler.cc
-file_test_SOURCES += file_test.cc
-file_test_SOURCES += metadata_access.hh
-file_test_SOURCES += input_archive.hh
-file_test_SOURCES += output_archive.hh
-
-file_matrix_test_LDADD =
-file_matrix_test_LDADD += $(BOOST_SIGNALS_LIB)
-file_matrix_test_SOURCES =
-file_matrix_test_SOURCES += test_util.hh test_util.cc
-file_matrix_test_SOURCES += file_matrix.hh file_matrix.cc
-file_matrix_test_SOURCES += matrix.hh matrix.cc
-file_matrix_test_SOURCES += input_archive.hh
-file_matrix_test_SOURCES += output_archive.hh
-file_matrix_test_SOURCES += metadata.hh metadata.cc
-file_matrix_test_SOURCES += snpfile.hh snpfile.cc
-file_matrix_test_SOURCES += byte_order_handler.hh byte_order_handler.cc
-file_matrix_test_SOURCES += file_matrix_test.cc
-
-
-readonly_matrix_test_LDADD =
-readonly_matrix_test_LDADD += $(BOOST_SIGNALS_LIB)
-readonly_matrix_test_SOURCES =
-readonly_matrix_test_SOURCES += test_util.hh test_util.cc
-readonly_matrix_test_SOURCES += array_matrix.hh array_matrix.cc
-readonly_matrix_test_SOURCES += file_matrix.hh file_matrix.cc
-readonly_matrix_test_SOURCES += matrix.hh matrix.cc
-readonly_matrix_test_SOURCES += input_archive.hh
-readonly_matrix_test_SOURCES += output_archive.hh
-readonly_matrix_test_SOURCES += metadata.hh metadata.cc
-readonly_matrix_test_SOURCES += snpfile.hh snpfile.cc
-readonly_matrix_test_SOURCES += byte_order_handler.hh byte_order_handler.cc
-readonly_matrix_test_SOURCES += readonly_matrix_test.cc
-
-
-archives_test_SOURCES =
-archives_test_SOURCES += input_archive.hh
-archives_test_SOURCES += output_archive.hh
-archives_test_SOURCES += archives_test.cc
-
-
-metadata_access_test_LDADD =
-metadata_access_test_LDADD += $(BOOST_SIGNALS_LIB)
-metadata_access_test_SOURCES =
-metadata_access_test_SOURCES += test_util.hh test_util.cc
-metadata_access_test_SOURCES += metadata.hh metadata.cc
-metadata_access_test_SOURCES += snpfile.hh snpfile.cc
-metadata_access_test_SOURCES += byte_order_handler.hh byte_order_handler.cc
-metadata_access_test_SOURCES += input_archive.hh
-metadata_access_test_SOURCES += output_archive.hh
-metadata_access_test_SOURCES += serialization_trait.hh
-metadata_access_test_SOURCES += metadata_access_test.cc
-
-
-metadata_types_test_LDADD =
-metadata_types_test_LDADD += $(BOOST_SIGNALS_LIB)
-metadata_types_test_SOURCES =
-metadata_types_test_SOURCES += test_util.hh test_util.cc
-metadata_types_test_SOURCES += metadata.hh metadata.cc
-metadata_types_test_SOURCES += snpfile.hh snpfile.cc
-metadata_types_test_SOURCES += byte_order_handler.hh byte_order_handler.cc
-metadata_types_test_SOURCES += input_archive.hh
-metadata_types_test_SOURCES += output_archive.hh
-metadata_types_test_SOURCES += serialization_trait.hh
-metadata_types_test_SOURCES += metadata_types_test.cc
-
-
-iterators_test_SOURCES =
-iterators_test_SOURCES += iterators.hh
-iterators_test_SOURCES += array_matrix.hh array_matrix.cc
-iterators_test_SOURCES += matrix.hh matrix.cc
-iterators_test_SOURCES += iterators_test.cc
-
-
-tabulate_test_SOURCES =
-tabulate_test_SOURCES += tabulate.hh
-tabulate_test_SOURCES += array_matrix.hh array_matrix.cc
-tabulate_test_SOURCES += matrix.hh matrix.cc
-tabulate_test_SOURCES += tabulate_test.cc
-
-
-metadata_filtering_test_SOURCES =
-metadata_filtering_test_SOURCES += matrix.hh matrix.cc
-metadata_filtering_test_SOURCES += array_matrix.hh array_matrix.cc
-metadata_filtering_test_SOURCES += metadata_filtering.hh
-metadata_filtering_test_SOURCES += metadata_filtering_test.cc
-
-
-make_test_snpfile_LDADD =
-make_test_snpfile_LDADD += $(BOOST_SIGNALS_LIB)
-make_test_snpfile_SOURCES =
-make_test_snpfile_SOURCES += metadata.hh metadata.cc
-make_test_snpfile_SOURCES += snpfile.hh snpfile.cc
-make_test_snpfile_SOURCES += matrix.hh matrix.cc
-make_test_snpfile_SOURCES += file_matrix.hh file_matrix.cc
-make_test_snpfile_SOURCES += byte_order_handler.hh byte_order_handler.cc
-make_test_snpfile_SOURCES += input_archive.hh
-make_test_snpfile_SOURCES += output_archive.hh
-make_test_snpfile_SOURCES += make_test_snpfile.cc
-
-
-test_test_snpfile_LDADD =
-test_test_snpfile_LDADD += $(BOOST_SIGNALS_LIB)
-test_test_snpfile_SOURCES =
-test_test_snpfile_SOURCES += metadata.hh metadata.cc
-test_test_snpfile_SOURCES += snpfile.hh snpfile.cc
-test_test_snpfile_SOURCES += matrix.hh matrix.cc
-test_test_snpfile_SOURCES += file_matrix.hh file_matrix.cc
-test_test_snpfile_SOURCES += byte_order_handler.hh byte_order_handler.cc
-test_test_snpfile_SOURCES += input_archive.hh
-test_test_snpfile_SOURCES += output_archive.hh
-test_test_snpfile_SOURCES += test_test_snpfile.cc
-
-
-row_metadata_experiment_LDADD = 
-row_metadata_experiment_LDADD += $(BOOST_SIGNALS_LIB)
-row_metadata_experiment_SOURCES =
-row_metadata_experiment_SOURCES += matrix.hh matrix.cc
-row_metadata_experiment_SOURCES += array_matrix.hh array_matrix.cc
-row_metadata_experiment_SOURCES += file_matrix.hh file_matrix.cc
-row_metadata_experiment_SOURCES += input_archive.hh
-row_metadata_experiment_SOURCES += output_archive.hh
-row_metadata_experiment_SOURCES += metadata.hh metadata.cc
-row_metadata_experiment_SOURCES += snpfile.hh snpfile.cc
-row_metadata_experiment_SOURCES += byte_order_handler.hh byte_order_handler.cc
-row_metadata_experiment_SOURCES += test_util.hh test_util.cc
-row_metadata_experiment_SOURCES += row_metadata_experiment.cc
-
-
-metadata_cache_prototype_SOURCES  =
-metadata_cache_prototype_SOURCES += metadata_cache_prototype.cc
-metadata_cache_prototype_LDFLAGS  =
-metadata_cache_prototype_LDFLAGS += -L.
-metadata_cache_prototype_LDADD  = 
-metadata_cache_prototype_LDADD += $(BOOST_SIGNALS_LIB)
-metadata_cache_prototype_LDADD += -lsnpfile
-
-
-matrix_benchmark_LDADD  = 
-matrix_benchmark_LDADD += $(BOOST_SIGNALS_LIB)
-matrix_benchmark_SOURCES  =
-matrix_benchmark_SOURCES += test_util.hh test_util.cc
-matrix_benchmark_SOURCES += file_matrix.hh file_matrix.cc
-matrix_benchmark_SOURCES += array_matrix.hh array_matrix.cc
-matrix_benchmark_SOURCES += matrix.hh matrix.cc
-matrix_benchmark_SOURCES += input_archive.hh
-matrix_benchmark_SOURCES += output_archive.hh
-matrix_benchmark_SOURCES += metadata.hh metadata.cc
-matrix_benchmark_SOURCES += snpfile.hh snpfile.cc
-matrix_benchmark_SOURCES += byte_order_handler.hh byte_order_handler.cc
-matrix_benchmark_SOURCES += timing.hh timing.cc
-matrix_benchmark_SOURCES += matrix_benchmark.cc
-
-
-matrix_benchmark_write_LDADD  = 
-matrix_benchmark_write_LDADD += $(BOOST_SIGNALS_LIB)
-matrix_benchmark_write_SOURCES  =
-matrix_benchmark_write_SOURCES += file_matrix.hh file_matrix.cc
-matrix_benchmark_write_SOURCES += matrix.hh matrix.cc
-matrix_benchmark_write_SOURCES += input_archive.hh
-matrix_benchmark_write_SOURCES += output_archive.hh
-matrix_benchmark_write_SOURCES += metadata.hh metadata.cc
-matrix_benchmark_write_SOURCES += snpfile.hh snpfile.cc
-matrix_benchmark_write_SOURCES += byte_order_handler.hh byte_order_handler.cc
-matrix_benchmark_write_SOURCES += timing.hh timing.cc
-matrix_benchmark_write_SOURCES += matrix_benchmark_write.cc
-
-
-matrix_benchmark_read_LDADD  = 
-matrix_benchmark_read_LDADD += $(BOOST_SIGNALS_LIB)
-matrix_benchmark_read_SOURCES  =
-matrix_benchmark_read_SOURCES += file_matrix.hh file_matrix.cc
-matrix_benchmark_read_SOURCES += matrix.hh matrix.cc
-matrix_benchmark_read_SOURCES += input_archive.hh
-matrix_benchmark_read_SOURCES += output_archive.hh
-matrix_benchmark_read_SOURCES += metadata.hh metadata.cc
-matrix_benchmark_read_SOURCES += snpfile.hh snpfile.cc
-matrix_benchmark_read_SOURCES += byte_order_handler.hh byte_order_handler.cc
-matrix_benchmark_read_SOURCES += timing.hh timing.cc
-matrix_benchmark_read_SOURCES += matrix_benchmark_read.cc
+noinst_PROGRAMS += row_metadata_experiment metadata_cache_prototype matrix_benchmark \
+	matrix_benchmark_write matrix_benchmark_read
+
+LDADD = $(top_builddir)/libsnpfile.la
+
+matrix_test_SOURCES = test_util.hh test_util.cc input_archive.hh output_archive.hh matrix_test.cc
+
+file_test_SOURCES = test_util.hh test_util.cc file_test.cc metadata_access.hh input_archive.hh \
+	output_archive.hh
+
+file_matrix_test_SOURCES = test_util.hh test_util.cc input_archive.hh output_archive.hh \
+	file_matrix_test.cc
+
+readonly_matrix_test_SOURCES = test_util.hh test_util.cc input_archive.hh output_archive.hh \
+	readonly_matrix_test.cc
 
+archives_test_SOURCES = input_archive.hh output_archive.hh archives_test.cc
+
+metadata_access_test_SOURCES = test_util.hh test_util.cc input_archive.hh output_archive.hh \
+	serialization_trait.hh metadata_access_test.cc
+
+metadata_types_test_SOURCES = test_util.hh test_util.cc input_archive.hh output_archive.hh \
+	serialization_trait.hh metadata_types_test.cc
+
+iterators_test_SOURCES = iterators.hh iterators_test.cc
+
+tabulate_test_SOURCES = tabulate.hh tabulate_test.cc
+
+metadata_filtering_test_SOURCES = metadata_filtering.hh metadata_filtering_test.cc
+
+make_test_snpfile_SOURCES = input_archive.hh output_archive.hh make_test_snpfile.cc
+
+test_test_snpfile_SOURCES = input_archive.hh output_archive.hh test_test_snpfile.cc
+
+row_metadata_experiment_SOURCES = input_archive.hh output_archive.hh test_util.hh test_util.cc \
+	row_metadata_experiment.cc
+
+matrix_benchmark_SOURCES  = test_util.hh test_util.cc input_archive.hh \
+	output_archive.hh timing.hh timing.cc matrix_benchmark.cc
+
+matrix_benchmark_write_SOURCES  = input_archive.hh output_archive.hh \
+	timing.hh timing.cc matrix_benchmark_write.cc
+
+matrix_benchmark_read_SOURCES  = input_archive.hh output_archive.hh \
+	timing.hh timing.cc matrix_benchmark_read.cc
+
+snpfile_genotype_count_SOURCES = genotype_count.cc
 
 snpfileincludedir = $(includedir)/snpfile
-snpfileinclude_HEADERS  =
-snpfileinclude_HEADERS += common.hh
-snpfileinclude_HEADERS += matrix.hh
-snpfileinclude_HEADERS += file_matrix.hh
-snpfileinclude_HEADERS += array_matrix.hh
-snpfileinclude_HEADERS += byte_order_handler.hh
-snpfileinclude_HEADERS += metadata.hh
-snpfileinclude_HEADERS += metadata_access.hh
-snpfileinclude_HEADERS += archive_common.hh
-snpfileinclude_HEADERS += archives.hh
-snpfileinclude_HEADERS += input_archive.hh
-snpfileinclude_HEADERS += output_archive.hh
-snpfileinclude_HEADERS += snpfile.hh
-snpfileinclude_HEADERS += serialization_trait.hh
-snpfileinclude_HEADERS += type_trait.hh
-snpfileinclude_HEADERS += iterators.hh
-snpfileinclude_HEADERS += tabulate.hh
-
-libsnpfile_a_SOURCES  =
-libsnpfile_a_SOURCES += common.hh
-libsnpfile_a_SOURCES += matrix.hh matrix.cc
-libsnpfile_a_SOURCES += file_matrix.hh file_matrix.cc
-libsnpfile_a_SOURCES += array_matrix.cc array_matrix.hh
-libsnpfile_a_SOURCES += byte_order_handler.cc byte_order_handler.hh
-libsnpfile_a_SOURCES += metadata.hh metadata.cc metadata_access.hh
-libsnpfile_a_SOURCES += archive_common.hh
-libsnpfile_a_SOURCES += archives.hh
-libsnpfile_a_SOURCES += input_archive.hh
-libsnpfile_a_SOURCES += output_archive.hh
-libsnpfile_a_SOURCES += snpfile.hh snpfile.cc
-libsnpfile_a_SOURCES += serialization_trait.hh
-libsnpfile_a_SOURCES += type_trait.hh
-
-text2snpfile_SOURCES =
-text2snpfile_SOURCES += text2snpfile.cc
-text2snpfile_LDFLAGS  =
-text2snpfile_LDFLAGS += -L.
-text2snpfile_LDADD  =
-text2snpfile_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-text2snpfile_LDADD += $(BOOST_SIGNALS_LIB)
-text2snpfile_LDADD += -lsnpfile
-
-snpfile2text_SOURCES =
-snpfile2text_SOURCES += snpfile2text.cc
-snpfile2text_LDFLAGS  =
-snpfile2text_LDFLAGS += -L.
-snpfile2text_LDADD  =
-snpfile2text_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile2text_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile2text_LDADD += -lsnpfile
-
-
-snpfile2fastPHASE_SOURCES =
-snpfile2fastPHASE_SOURCES += snpfile2fastPHASE.cc
-snpfile2fastPHASE_LDFLAGS  =
-snpfile2fastPHASE_LDFLAGS += -L.
-snpfile2fastPHASE_LDADD  =
-snpfile2fastPHASE_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile2fastPHASE_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile2fastPHASE_LDADD += -lsnpfile
-
-fastPHASE2snpfile_SOURCES =				   
-fastPHASE2snpfile_SOURCES += fastPHASE2snpfile.cc	   
-fastPHASE2snpfile_LDFLAGS  =				   
-fastPHASE2snpfile_LDFLAGS += -L.			   
-fastPHASE2snpfile_LDADD  =				   
-fastPHASE2snpfile_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)	   
-fastPHASE2snpfile_LDADD += $(BOOST_SIGNALS_LIB)		   
-fastPHASE2snpfile_LDADD += -lsnpfile                       
-
-
-snpfile2haploview_SOURCES =
-snpfile2haploview_SOURCES += snpfile2haploview.cc
-snpfile2haploview_LDFLAGS  =
-snpfile2haploview_LDFLAGS += -L.
-snpfile2haploview_LDADD  =
-snpfile2haploview_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile2haploview_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile2haploview_LDADD += -lsnpfile
-
-
-beagle_phase_snpfile_SOURCES =				 
-beagle_phase_snpfile_SOURCES += beagle_phase_snpfile.cc	 
-beagle_phase_snpfile_LDFLAGS  =				 
-beagle_phase_snpfile_LDFLAGS += -L.			 
-beagle_phase_snpfile_LDADD  =				 
-beagle_phase_snpfile_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)	 
-beagle_phase_snpfile_LDADD += $(BOOST_SIGNALS_LIB)		 
-beagle_phase_snpfile_LDADD += -lsnpfile                     
-
-snpfile_genotype_count_SOURCES =
-snpfile_genotype_count_SOURCES += genotype_count.cc
-snpfile_genotype_count_LDFLAGS  =
-snpfile_genotype_count_LDFLAGS += -L.
-snpfile_genotype_count_LDADD  =
-snpfile_genotype_count_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile_genotype_count_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_genotype_count_LDADD += -lsnpfile
-
-snpfile_phenotypes_SOURCES =
-snpfile_phenotypes_SOURCES += snpfile_phenotypes.cc
-snpfile_phenotypes_LDFLAGS  =
-snpfile_phenotypes_LDFLAGS += -L.
-snpfile_phenotypes_LDADD  =
-snpfile_phenotypes_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile_phenotypes_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_phenotypes_LDADD += -lsnpfile
-
-snpfile_markers_SOURCES =
-snpfile_markers_SOURCES += snpfile_markers.cc
-snpfile_markers_LDFLAGS  =
-snpfile_markers_LDFLAGS += -L.
-snpfile_markers_LDADD  =
-snpfile_markers_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile_markers_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_markers_LDADD += -lsnpfile
-
-snpfile_metadata_info_SOURCES =
-snpfile_metadata_info_SOURCES += snpfile_metadata_info.cc
-snpfile_metadata_info_LDFLAGS  =
-snpfile_metadata_info_LDFLAGS += -L.
-snpfile_metadata_info_LDADD  =
-snpfile_metadata_info_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_metadata_info_LDADD += -lsnpfile
-
-snpfile_set_metadata_SOURCES =
-snpfile_set_metadata_SOURCES += snpfile_set_metadata.cc
-snpfile_set_metadata_LDFLAGS  =
-snpfile_set_metadata_LDFLAGS += -L.
-snpfile_set_metadata_LDADD  =
-snpfile_set_metadata_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile_set_metadata_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_set_metadata_LDADD += -lsnpfile
-
-snpfile_get_metadata_SOURCES =
-snpfile_get_metadata_SOURCES += snpfile_get_metadata.cc
-snpfile_get_metadata_LDFLAGS  =
-snpfile_get_metadata_LDFLAGS += -L.
-snpfile_get_metadata_LDADD  =
-snpfile_get_metadata_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile_get_metadata_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_get_metadata_LDADD += -lsnpfile
-
-snpfile_split_on_column_SOURCES =
-snpfile_split_on_column_SOURCES += snpfile_split_on_column.cc
-snpfile_split_on_column_LDFLAGS =
-snpfile_split_on_column_LDFLAGS += -L.
-snpfile_split_on_column_LDADD  =
-snpfile_split_on_column_LDADD += $(BOOST_PROGRAM_OPTIONS_LIB)
-snpfile_split_on_column_LDADD += $(BOOST_SIGNALS_LIB)
-snpfile_split_on_column_LDADD += -lsnpfile
+snpfileinclude_HEADERS = common.hh matrix.hh file_matrix.hh array_matrix.hh \
+	byte_order_handler.hh metadata.hh metadata_access.hh archive_common.hh \
+	archives.hh input_archive.hh output_archive.hh snpfile.hh serialization_trait.hh \
+	type_trait.hh iterators.hh tabulate.hh
+
+libsnpfile_la_SOURCES = common.hh matrix.hh matrix.cc file_matrix.hh file_matrix.cc \
+	array_matrix.cc array_matrix.hh byte_order_handler.cc byte_order_handler.hh \
+	metadata.hh metadata.cc metadata_access.hh archive_common.hh archives.hh \
+	input_archive.hh output_archive.hh snpfile.hh snpfile.cc serialization_trait.hh \
+	type_trait.hh
+libsnpfile_la_LIBADD = $(BOOST_PROGRAM_OPTIONS_LIB) $(BOOST_SIGNALS_LIB)
+
--- a/configure.in
+++ b/configure.in
@@ -1,10 +1,11 @@
 AC_INIT(snpfile, 2.0.1, mailund@birc.au.dk)
 AM_INIT_AUTOMAKE
+AC_CONFIG_MACRO_DIR([m4])
 AM_CONFIG_HEADER(config.hh)
 
+LT_INIT
 AC_PROG_CXX
 AC_PROG_INSTALL
-AC_PROG_RANLIB
 
 if test "x$prefix" != xNONE; then
    thePREFIX=$prefix
